local bind_methods
bind_methods = require("lib/moon").bind_methods
local TimerContext
TimerContext = require("timer").TimerContext
local GameMode
do
  local _class_0
  local _parent_0 = TimerContext
  local _base_0 = {
    draw = function(self)
      return nil
    end,
    _update = function(self, dt)
      _class_0.__parent.__base._update(self, dt)
      return self:update(dt)
    end,
    update = function(self, dt)
      return nil
    end,
    resize = function(self, w, h)
      return nil
    end,
    load = function(self)
      return nil
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  _class_0 = setmetatable({
    __init = function(self, state)
      _class_0.__parent.__init(self)
      self.state = state
      self.methods = bind_methods(self)
      local mt = getmetatable(self)
      local newindex
      newindex = function(t, k)
        local val = mt[k]
        if val == nil then
          val = state[k]
        end
        return val
      end
      mt.__index = newindex
    end,
    __base = _base_0,
    __name = "GameMode",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        local parent = rawget(cls, "__parent")
        if parent then
          return parent[name]
        end
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  GameMode = _class_0
end
return {
  GameMode = GameMode
}
