local tactile = require('lib/tactile')
pcall(function()
  return love.joystick.loadGamepadMappings('lib/gamecontrollerdb.txt')
end)
local Controls = {
  Horizontal = tactile.newControl():addAxis(tactile.gamepadAxis(1, 'leftx')):addButtonPair(tactile.keys('a', 'left'), tactile.keys('d', 'right')),
  Vertical = tactile.newControl():addAxis(tactile.gamepadAxis(1, 'lefty')):addButtonPair(tactile.keys('w', 'up'), tactile.keys('s', 'down')),
  Primary = tactile.newControl():addAxis(tactile.gamepadAxis(1, 'triggerleft')):addAxis(tactile.gamepadAxis(1, 'triggerright')):addButton(tactile.gamepadButtons(1, 'a')):addButton(tactile.keys('x')):addButton(tactile.keys('return')):addButton(tactile.keys('space')),
  Secondary = tactile.newControl():addAxis(tactile.gamepadAxis(1, 'triggerleft')):addAxis(tactile.gamepadAxis(1, 'triggerright')):addButton(tactile.gamepadButtons(1, 'b')):addButton(tactile.keys('z')),
  Tertiary = tactile.newControl():addButton(tactile.keys('c')),
  Quaternary = tactile.newControl():addButton(tactile.keys('v'))
}
return {
  Controls = Controls
}
