local Script = require('scripts/script')
local Bullet
do
  local _class_0
  local _parent_0 = Script
  local _base_0 = {
    onAdd = function(self, e)
      return e.events:listen('collide', function(o)
        if o.name ~= e.range_attacker.name then
          if o.health ~= nil then
            o.events:say("damage", {
              damage = 2,
              attacker = e.range_attacker
            })
            return e.events:say("kill")
          end
        end
      end)
    end,
    update = function(self, e, dt)
      if e.tx < 0 or e.tx > 10000 or e.ty < 0 or e.ty > 10000 then
        return e.events:say("kill")
      end
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  _class_0 = setmetatable({
    __init = function(self, ...)
      return _class_0.__parent.__init(self, ...)
    end,
    __base = _base_0,
    __name = "Bullet",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        local parent = rawget(cls, "__parent")
        if parent then
          return parent[name]
        end
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Bullet = _class_0
end
return Bullet
